function [phaps,ztd] = ctSent_GACOS_quick(gacospath,slcday,ifgday,lonlat,inc)
nslc = length(slcday);
nps = size(lonlat,1);
phaps_sm = zeros(nps,nslc,'single');
ztd = zeros(nps,nslc,'single');
% ref = ps_setref;
progressBar = CommandLineProgressBar(nslc);
progressBar.message = 'Generating GACOS: ';
progressBar.barLength = 42;
parfor i = 1:nslc
ztdpath1 = [gacospath,'/',num2str(slcday(i)),'.ztd.tif'];
% fid = fopen(ztdpath1,'rb');
% ztd1 = fread(fid,[wid, len],'float');
% fclose(fid);
data = readtiff(ztdpath1);
Lon = data.lon;Lat = data.lat;ztd1 = double(data.z);
dztd = ztd1/(0.055165/(4*pi));
%fprintf('%d ZTD INTERPOLATING... \n',i);
Fgacos = scatteredInterpolant(Lon(:),Lat(:),dztd(:));
temp = Fgacos(double(lonlat(:,1)),double(lonlat(:,2)));
% temp = temp - nanmean(temp(ref));
ztd(:,i) = temp;
phaps_sm(:,i) = temp./cosd(inc);
progressBar.increment;
%fprintf('%d / %d SLC ZTD COMPUTED... \n',i,nslc);
end
[~,ifgday_ix]=ismember(ifgday,slcday);
phaps = phaps_sm(:,ifgday_ix(:,2))-phaps_sm(:,ifgday_ix(:,1));
end

