function [ph_s,ph_so] = ctSent_Stacking(X,Y,ac_date,inf_list,ph_sbas,modelflag,topoflag,bperp,inc,smooth,value_spline)
%if modelflag == 1, linear displacement;
%if modelflag == 1.5, Wavelet Denoising low pass filter;
%if modelflag == 2, fitted curve;
stacksize = length(ac_date);
G = SR2SBAS(inf_list,stacksize);%construct conversion matrix from Single Reference to SBAS
infdate = ac_date(inf_list);
iteration = 2;
phaps = zeros(size(ph_sbas,1),size(ph_sbas,2));
phapssr = inf(size(ph_sbas,1),stacksize);
ph_sbas_ori = ph_sbas;
ancold = inf(stacksize,1);
for i = 1:iteration
%     if i == 1
%         phaps_new = phaps_old;
%     end
disp(['Doing the Stacking for Iteration #:',num2str(i)]);
if modelflag==1
    phaps_sr_old = phapssr;
ph_sbas = ph_sbas_ori-phaps;
%Estimate linear part
[ph_s,~] = uw_invert_sm(inf_list,ph_sbas,stacksize);
ph_s = [zeros(size(ph_s,1),1),ph_s];
DateVector = datevec(num2str(ac_date),'yyyymmdd');
decy = decyear(DateVector);
[simdef,demerr] = model_defo(decy,ph_s,bperp);
simdef = simdef+demerr;
simdef = G *simdef;

elseif modelflag == 1.5
[ph_s,~] = uw_invert_sm(inf_list,ph_sbas-phaps,stacksize);
ph_s = [zeros(size(ph_s,1),1),ph_s];    
ind = knnsearch([X,Y],[X,Y],'K',49);
for id = 2:stacksize
    temp = ph_s(:,id);
    ph_sm(:,id) = mean(temp(ind),2);
end
ph_lowpass = zeros(size(ph_sm));
npart = 200;npoint = size(ph_sm,1);
partID = floor(linspace(1,npoint,npart+1));
for pid = 1:npart
    ph_lowpass(partID(pid):partID(pid+1),:) = wdenoise(ph_sm(partID(pid):partID(pid+1),:)',5,'Wavelet','sym4')';
    fprintf('Wavelet Denoising %d / %d  part \n',pid,npart);
end
simdef = G * ph_lowpass';
else
%       if i == iteration
%           disp(['remove function fitting in the last round...']);
%           value_spline = 1;
%       end
% phaps_sr_old = phapssr;
% ph_sbas = ph_sbas_ori-phaps;
[ph_filter,demerr] = css_filter(ph_sbas-phaps,ac_date,inf_list,bperp,inc,topoflag,smooth,value_spline);
simdef = G * [ph_filter'+demerr'];
end      
[phaps, phapssr,Inc] = ctSent_multi_stacking(infdate,ac_date,(ph_sbas'-simdef)');
% ancnow = get_anc(ac_date,phapssr);
% ind = ancnow>ancold;
% phapssr(:,ind) = phaps_sr_old(:,ind);
% phaps = phapssr * Inc';
anc(:,i) = get_anc(ac_date,phapssr);
% ancold = anc(:,i);
% anc_new = anc(i,:);
end
% [~,demerr] = model_defo(decy,ph_s,bperp);
demerr = demerr*G';
ph_sbas = ph_sbas_ori-phaps-demerr;
% phaps_est = ph_sbas_ori - ph_sbas;
[ph_s,~] = uw_invert_sm(inf_list,ph_sbas,stacksize);
ph_s = [zeros(size(ph_s,1),1),ph_s];
DateVector = datevec(num2str(ac_date),'yyyymmdd');
decy = decyear(DateVector);
B = [ones(stacksize,1),decy-decy(1)];
para = pinv(B'*B)*B'*ph_s';
para = para';
velofinal = para(:,2);
[ph_so,~] = uw_invert_sm(inf_list,ph_sbas_ori-demerr,stacksize);
ph_so = [zeros(size(ph_so,1),1),ph_so];
para = pinv(B'*B)*B'*ph_so';
para = para';
velofinalo = para(:,2); 
figure;
idx = floor(linspace(1,stacksize,16));
for i = 1:16
subplot(4,4,i);scatter(X,Y,2,ph_so(:,idx(i)),'filled');%set(gca,'clim',[-5 5]);
end
figure;
idx = floor(linspace(1,stacksize,16));
for i = 1:16
subplot(4,4,i);scatter(X,Y,2,ph_s(:,idx(i)),'filled');%set(gca,'clim',[-5 5]);
end
end

function [los_out,topo_out] = css_filter(PhU,ac_date,inf_list,bperp,inc,topoflag,smooth,value_spline)
n_image = length(ac_date);
bperp = bperp - bperp(1);
rng=864000;
wavelength=0.056;
pspline=value_spline;
nsar=length(unique(ac_date));
[npixel,n_intf] = size(PhU);
DateVector = datevec(num2str(ac_date),'yyyymmdd');
t_sar = decyear(DateVector);
t_sar = t_sar - t_sar(1);
dt=diff(t_sar);
xx_sar=t_sar/mean(dt);
G1=zeros(n_intf,n_image);
for i=1:n_intf
    G1(i,inf_list(i,1))=-1;
    G1(i,inf_list(i,2))=1;
end
dBp = G1*bperp;
if (topoflag>0)   
    beta=4*pi/(wavelength*rng*sin(mean(inc)*pi/180));
    G1 = [G1,beta*dBp];  
    H2=zeros(nsar-2,nsar+1);
    for k=1:nsar-2
        H2(k,k)=-1/dt(k);
        H2(k,k+1)=(1/dt(k)+1/dt(k+1));
        H2(k,k+2)=-1/dt(k+1); %assuming the velocity is the same
    end
else
     H2=zeros(nsar-2,nsar);
    for k=1:nsar-2
        H2(k,k)=-1/dt(k);
        H2(k,k+1)=(1/dt(k)+1/dt(k+1));
        H2(k,k+2)=-1/dt(k+1); %assuming the velocity is the same
    end
 
end
if (smooth>0)
  G2=smooth*H2;
  d2=zeros(nsar-2,1); %for smoothing;
else
    G2=[];
    d2=[];
end
G=[G1;G2];
G(:,1)=[]; % take out master as ref by setting to zero
Ginv=pinv(G);
los_out = zeros(npixel,nsar);
topo_out = zeros(npixel,nsar);
progressBar = CommandLineProgressBar(npixel);
progressBar.message = 'Iterative Stacking: ';
progressBar.barLength = 42;  
parfor k=1:npixel
    d1=(PhU(k,:))';
    d=[d1;d2];
    xx=Ginv*d;
     los_out_this_pixel= [0;xx(1:nsar-1)];
     topo_out_this_pixel = xx(nsar);
     if (pspline < 1) % fit a spline function if necessary
       pp_this_pixel=csaps(xx_sar,double(los_out_this_pixel),pspline);
       los_out_this_pixel_new=fnval(pp_this_pixel,xx_sar);
       los_out_this_pixel=los_out_this_pixel_new-los_out_this_pixel_new(1);
     end 
     los_out(k,:)=los_out_this_pixel;
     topo_out(k,:)=beta*bperp*topo_out_this_pixel;
%      if k == all_step * p
%        disp(['progress: ', num2str(1*p),'%']);
%        p = p+1;
%     end
progressBar.increment;
end
end
function G = SR2SBAS(ifg_list,stacksize)
n_ifg = size(ifg_list,1);
G=zeros(n_ifg,stacksize);
for i=1:n_ifg
    G(i,ifg_list(i,1))=-1;
    G(i,ifg_list(i,2))=1;
end
end
function Velorate = simulateInterseismic(Y)
%InSAR parameters
wavelength = 0.056;
slantrange = 650000;
inc_angle  = 35.0*pi/180;% [rad]
heading = 190;%descending
KK         = -4*pi/wavelength;
%
locking_depth = 10;%km
slip_rate = 20;%mm/yr
v_creep = 5;%mm/yr
Hcreep = 5;%km
creep = v_creep*(1/pi*atan(Hcreep./Y));
uv = slip_rate./pi.*atan(Y./locking_depth) + creep;
Velorate = uv./1000;%m/yr
Velorate = Velorate * KK;
end
function anc = get_anc(day_sar,aps_in,varargin)
%
%Usage: anc=get_anc(day_sar,aps_in,indx_box);
%
% added the option to calculate the ANC for a small area defined by the pixel index
% Last Update by Kang Wang on 07/07/2017

Nsar=length(day_sar);
rms_alpha=zeros(Nsar,1);


for i=1:Nsar
 this_image_all=aps_in(:,i);
 if length (varargin) >0 ;
   indx_box = varargin{1};
   this_image=this_image_all(indx_box);
 else
   this_image=this_image_all;
 end
 indx_good=~isnan(this_image);
 alpha_good=this_image(indx_good);
 Ngood=length(alpha_good);
 alpha_mean=mean(alpha_good);
% alpha_mean=0;
 rms_alpha(i)=sqrt(sum((alpha_good-alpha_mean).^2)/Ngood);
end

anc=10*rms_alpha/max(rms_alpha);
end
function [ph_uw,ph_res] = uw_invert_sm(ifgday_ix,phU,n_image)
n_ifg = size(phU,2);
G=zeros(n_ifg,n_image);
for i=1:n_ifg
    G(i,ifgday_ix(i,1))=-1;
    G(i,ifgday_ix(i,2))=1;
end
G(:,1)=[]; % take out master as ref by setting to zero
ph_uw = lscov(G,double(phU'))';
ph_res=single(phU - (G*ph_uw')');
end
function [ph_uw,ph_res] = remove_demerror(ifgday_ix,phU,bperp,n_image)
[n_point,n_ifg] = size(phU);
G=zeros(n_ifg,n_image);
for i=1:n_ifg
    G(i,ifgday_ix(i,1))=-1;
    G(i,ifgday_ix(i,2))=1;
end
G(:,1)=[]; % take out master as ref by setting to zero
ph_uw = lscov(G,double(phU'))';
ph_res=single(phU - (G*ph_uw')');
end
function [defo,demerr] = model_defo(decy,obe,bperp)
bperp = bperp - bperp(1);
t = decy(:,1)-decy(1,1);
B = [ones(length(t),1), t, sin(2*pi*t), sin(4*pi*t), ...
    cos(2*pi*t), cos(4*pi*t),bperp];
% B = [ones(length(t),1), t, sin(2*pi*t), sin(4*pi*t), ...
%     cos(2*pi*t), cos(4*pi*t)];
nB = size(B,2);
%Bsp = MintsBSpline(1,t(1:40:end),t);
knots = [-0.01,-0.01,t(1):0.5:t(end),t(end)+0.01,t(end)+0.01];
Bsp = bspline_basismatrix(3,knots,t);
nBsp = size(Bsp,2);
B = [B,Bsp];
reg = ones(size(B,2),1);
reg(1:nB) = 0;
lambda = 10;
reg = diag(reg)*lambda;
obereg = zeros(size(obe,1),nB+nBsp);
para = pinv([B;reg]'*[B;reg])*[B;reg]'*[obe,obereg]';
para1 = para;
para1(7,:) = 0;
defo = B*para1;
demerr = B*(para-para1);
end