function [velo,res] = ctSent_singlePeridogram(savepath,swathID,ovlID,esdflag)
load('slcpath.mat');
for i = 1:length(slcpath)
ac_date(i,1) = str2double(slcpath(i).date);
end
dataname = [savepath,'/IW',num2str(swathID),'Ovl',num2str(ovlID),'final.mat'];
if esdflag
    esd = load([savepath,'/esd.mat']);
    esd = esd.esd;
else
    esd = zeros(length(slcpath),1);
end
load(dataname,'ph_emiUp');
load(dataname,'ph_emiLo');
load(dataname,'Lat');
load(dataname,'Lon');
load(dataname,'Elevation');
numslc = length(ac_date);
DateVector = datevec(num2str(ac_date),'yyyymmdd');
decy = decyear(DateVector);
B = decy-decy(1);
[m,n] = size(Lat);
[~,~,numslc] = size(ph_emiUp);
res =  nan(m*n,1);
velo =  nan(m*n,1);
allstep = m*n;
progressBar = CommandLineProgressBar(allstep);
progressBar.message = 'BOI Time Series Offset Estimating: ';
progressBar.barLength = 42;
ph_uw = angle(ph_emiUp.*conj(ph_emiLo));
ph_uw = reshape(ph_uw,m*n,numslc);
parfor  i = 1:allstep
    para = pinv(B'*B)*B'*ph_uw(i,:)';
    ph_res = B * para - ph_uw(i,:)';
    velo(i,1) = para;
    res(i,1)  = sqrt(sum(ph_res.*ph_res)./(numslc-2));
    progressBar.increment;
end
velo = reshape(velo,m,n);
res = reshape(res,m,n);
% % ph_uw = reshape(ph_uw,m,n,numslc);
% % ph_res = reshape(ph_res,m,n,nifg);
% oldFolder = cd(savepath);
% savename = ['IW',num2str(swathID),'Ovl',num2str(ovlID),'veloFinal.mat'];
% save(savename,'velo','ph_uw','ph_res','res','Lon','Lat','Ele');
% newfolder = cd(oldFolder);
end
function [misrad,maxcoh] = estimateOffset(phEMI,nifg,startID,endID)
misrad  = zeros(nifg,1);
maxcoh = misrad;
for j = 1:nifg
    temp = phEMI(:,startID:endID,j);
%     temp = filt2(temp,1,30,'lp');
    [misrad(j,1),maxcoh(j,1)] = periodogram(temp(:));
end
% meancoh = mean(maxcoh);
% if meancoh<0.9
%     misrad = nan(nifg,1);
% end
end
function [ph_uw,ph_res] = uw_invert_sm(ifgday_ix,phU,maxcoh,n_image)
n_ifg = size(phU,1);
G=zeros(n_ifg,n_image);
for i=1:n_ifg
    G(i,ifgday_ix(i,1))=-1;
    G(i,ifgday_ix(i,2))=1;
end
G(:,1)=[]; % take out master as ref by setting to zero
ph_uw = lscov(G,double(phU),maxcoh);
ph_res=single(phU - (G*ph_uw));
ph_uw = [0;ph_uw];
end
function [misrad,maxcoh] = periodogram(diffph)
diffph = diffph(:);
tempph = double(-1:0.004:1);
coh = zeros(length(tempph),1,'double');
for i = 1:length(tempph)
coh(i,1) = abs(real(mean(exp(1j*(diffph-tempph(i))))));
end
ind = find(coh == max(coh));
maxcoh = max(coh);
misrad = tempph(ind(1));
end