function ph_all = ps_deramp(lonlat,ph_all,mask,degree)
fprintf(['Deramping computed on the fly. \n'])

if nargin<3
    if exist('deramp_degree.mat','file')==2
        try 
            load('deramp_degree.mat','degree')
            fprintf('Found deramp_degree.mat file will use that value to deramp\n')
        catch
            degree = 1;
        end
    else
        degree = 1;
    end
end

% detrenting of the data
if degree == 1
    % z = ax + by+ c
    A = double([lonlat(~mask,1:2) ones([size(lonlat(~mask,1:2),1) 1])]);    
    fprintf('**** z = ax + by+ c\n')
elseif degree == 1.5
    % z = ax + by+ cxy + d
    A = double([lonlat(~mask,1:2) lonlat(~mask,1:2).*lonlat(~mask,1:2) ones([size(lonlat(~mask,1:2),1) 1])]);    
    fprintf('**** z = ax + by+ cxy + d\n')
elseif degree ==2
    % z = ax^2 + by^2 + cxy + d
    A = double([(lonlat(~mask,1:2)).^2 lonlat(~mask,1).*lonlat(~mask,2) ones([size(lonlat(~mask,1:2),1) 1])]);
    fprintf('**** z = ax^2 + by^2 + cxy + d \n')
elseif degree ==3
    % z = ax^2 + by^2 + cxy + d
    A = double([(lonlat(~mask,1:2)).^3 (lonlat(~mask,1:2)).^2 lonlat(~mask,1).^2.*lonlat(~mask,2) lonlat(~mask,1).*lonlat(~mask,2).^2 lonlat(~mask,1).*lonlat(~mask,2) ones([size(lonlat(~mask,1:2),1) 1])]);
    fprintf('**** z = ax^2 + by^2 + cxy + d \n')
end

        coeff = lscov(A,ph_all(~mask));
if degree == 1
    % z = ax + by+ c
    A = double([lonlat(:,1:2) ones([size(lonlat(:,1:2),1) 1])]);    
    fprintf('**** z = ax + by+ c\n')
elseif degree == 1.5
    % z = ax + by+ cxy + d
    A = double([lonlat(:,1:2) lonlat(:,1:2).*lonlat(:,1:2) ones([size(lonlat(:,1:2),1) 1])]);    
    fprintf('**** z = ax + by+ cxy + d\n')
elseif degree ==2
    % z = ax^2 + by^2 + cxy + d
    A = double([(lonlat(:,1:2)).^2 lonlat(:,1).*lonlat(:,2) ones([size(lonlat(:,1:2),1) 1])]);
    fprintf('**** z = ax^2 + by^2 + cxy + d \n')
    elseif degree ==3
    % z = ax^2 + by^2 + cxy + d
    A = double([(lonlat(:,1:2)).^3 (lonlat(:,1:2)).^2 lonlat(:,1).^2.*lonlat(:,2) lonlat(:,1).*lonlat(:,2).^2 lonlat(:,1).*lonlat(:,2) ones([size(lonlat(:,1:2),1) 1])]);
    fprintf('**** z = ax^2 + by^2 + cxy + d \n')
end
        ph_ramp=A*coeff;
        ph_all = ph_all-ph_ramp;

end       
